﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="TestMultipointV2.aspx.cs" Inherits="Geosys.Prototypes.MapSuite.WebEdition.Pages.TestMultipointV2" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
<head id="Head1" runat="server">
    <title></title>

   <script type="text/javascript">
       var OnMapCreating = function(map) {
           OpenLayers.Control.ModifyFeature.prototype.collectDragHandle = function() {
               var style_mark = OpenLayers.Util.extend({}, OpenLayers.Feature.Vector.style['default']);

               style_mark.graphicWidth = 24;
               style_mark.graphicHeight = 24;
               style_mark.graphicXOffset = -(style_mark.graphicWidth / 2);  // this is the default value
               style_mark.graphicYOffset = -style_mark.graphicHeight;
               //Here you specify the image what you want
               style_mark.externalGraphic = "../Resources/Images/markers/move.png";
               // Here is the tooltip, but graphicTitle only works in Firefox and Internet Explorer
               style_mark.graphicTitle = "Move here to move the whole shape";

               var geometry = this.feature.geometry;
               var center = geometry.getBounds().getCenterLonLat();
               var originGeometry = new OpenLayers.Geometry.Point(center.lon, center.lat);

               //Here you add the style you have defined before to the point feature.
               var origin = new OpenLayers.Feature.Vector(originGeometry, null, style_mark);
               originGeometry.move = function(x, y) {
                   OpenLayers.Geometry.Point.prototype.move.call(this, x, y);
                   geometry.move(x, y);
               };
               origin._sketch = true;
               this.dragHandle = origin;
               this.layer.addFeatures([this.dragHandle], { silent: true });
           }

           OpenLayers.Control.ModifyFeature.prototype.collectRadiusHandle = function() {
               var geometry = this.feature.geometry;
               var bounds = geometry.getBounds();
               var center = bounds.getCenterLonLat();
               var originGeometry = new OpenLayers.Geometry.Point(center.lon, center.lat);
               var radiusGeometry = new OpenLayers.Geometry.Point(bounds.right, bounds.bottom);

               var style_mark = OpenLayers.Util.extend({}, OpenLayers.Feature.Vector.style['default']);

               style_mark.graphicWidth = 24;
               style_mark.graphicHeight = 24;
               style_mark.graphicXOffset = -(style_mark.graphicWidth / 2);  // this is the default value
               style_mark.graphicYOffset = -style_mark.graphicHeight;
               //Here you specify the image what you want
               style_mark.externalGraphic = "../Resources/Images/markers/rotate.png";
               // Here is the tooltip, but graphicTitle only works in Firefox and Internet Explorer
               style_mark.graphicTitle = "Move here to rotate the whole shape";

               //Here you add the style you have defined before to the point feature.
               var radius = new OpenLayers.Feature.Vector(radiusGeometry, null, style_mark);
               var resize = (this.mode & OpenLayers.Control.ModifyFeature.RESIZE);
               var reshape = (this.mode & OpenLayers.Control.ModifyFeature.RESHAPE);
               var rotate = (this.mode & OpenLayers.Control.ModifyFeature.ROTATE);

               radiusGeometry.move = function(x, y) {
                   OpenLayers.Geometry.Point.prototype.move.call(this, x, y);
                   var dx1 = this.x - originGeometry.x;
                   var dy1 = this.y - originGeometry.y;
                   var dx0 = dx1 - x;
                   var dy0 = dy1 - y;
                   if (rotate) {
                       var a0 = Math.atan2(dy0, dx0);
                       var a1 = Math.atan2(dy1, dx1);
                       var angle = a1 - a0;
                       angle *= 180 / Math.PI;
                       geometry.rotate(angle, originGeometry);
                   }
                   if (resize) {
                       var scale, ratio;
                       // 'resize' together with 'reshape' implies that the aspect 
                       // ratio of the geometry will not be preserved whilst resizing 
                       if (reshape) {
                           scale = dy1 / dy0;
                           ratio = (dx1 / dx0) / scale;
                       } else {
                           var l0 = Math.sqrt((dx0 * dx0) + (dy0 * dy0));
                           var l1 = Math.sqrt((dx1 * dx1) + (dy1 * dy1));
                           scale = l1 / l0;
                       }
                       geometry.resize(scale, originGeometry, ratio);
                   }
               };
               radius._sketch = true;
               this.radiusHandle = radius;
               this.layer.addFeatures([this.radiusHandle], { silent: true });
           }


       }
   </script>

</head>
<body>
    <form id="form1" runat="server">
    <asp:ScriptManager ID="ScriptManager1" runat="server">
    </asp:ScriptManager>
    <div>
        <asp:Button ID="btnCreateMultiPoints" runat="server" Text="CreateMultiPoints" OnClick="btnCreateMultiPoints_Clicked" />
        <%--<asp:TextBox ID="txtDistance" runat="server" />--%>
        <asp:Button ID="btnDeletePoints" OnClientClick="deleteAllPoints();return false" Text="DeleteAllPoints" runat="server" />
        <asp:Button ID="btnEdit" OnClientClick="editme();return false;" Text="editMode" runat="server" />
        <ThinkGeo:Map ID="Map1" runat="server" Height="480px" Width="575px">
        </ThinkGeo:Map>
    </div>
    </form>
    
     <script type="text/javascript">
         function editme() {
             Map1.SetDrawMode('Modify');
             
//           i dont want to use that anymore
//             var modifyControl = Map1.GetMapParser().paintControls["Modify"];
//             var layer = Map1.GetMapParser().editOverlay;
//             //Get the MultipointShape feature
//             var feature = layer.features[0];
//             var selectControl = modifyControl.selectControl.clickFeature(feature);

         }

         function deleteAllPoints() {
             Map1.ClearFeatures();
         }
        

         var OnMapCreated = function(map) {
             if (Map1.GetMapParser() != null && Map1.GetMapParser().paintControls != null) {
                 var modifyControl = Map1.GetMapParser().paintControls["Modify"];
                 var layer = Map1.GetMapParser().editOverlay;
                 if (layer != null) {
                     //The "select" is the style for Selected points. 
                     layer.styleMap = new OpenLayers.StyleMap(
                {
                    'select': {
                        fillColor: "red",
                        fillOpacity: 0.4,
                        hoverFillColor: "white",
                        hoverFillOpacity: 0.8,
                        strokeColor: "blue",
                        strokeOpacity: 1,
                        strokeWidth: 2,
                        strokeLinecap: "round",
                        strokeDashstyle: "solid",
                        hoverStrokeColor: "red",
                        hoverStrokeOpacity: 1,
                        hoverStrokeWidth: 0.2,
                        pointRadius: 6,
                        hoverPointRadius: 1,
                        hoverPointUnit: "%",
                        pointerEvents: "visiblePainted",
                        cursor: "pointer"
                    }
                });

                     layer.events.register("afterfeaturemodified", this, function(args) {
                         if (args.feature.geometry.CLASS_NAME == "OpenLayers.Geometry.MultiPoint") {
                             var layer = args.object;
                             for (var i in layer.features) {
                                 var feature = layer.features[i];
                                 if (feature.geometry.CLASS_NAME == "OpenLayers.Geometry.MultiPoint") {
                                     layer.drawFeature(feature, "default");
                                 }
                             }
                         }
                     });
                 }
             }
         }

      

    </script>
</body>
</html>